/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the NetsuiteDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &NetsuiteDestinationAllOf{}

// NetsuiteDestinationAllOf struct for NetsuiteDestinationAllOf
type NetsuiteDestinationAllOf struct {
	OAuthId  *int32  `json:"o_auth_id,omitempty"`
	Endpoint *string `json:"endpoint,omitempty"`
}

// NewNetsuiteDestinationAllOf instantiates a new NetsuiteDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewNetsuiteDestinationAllOf() *NetsuiteDestinationAllOf {
	this := NetsuiteDestinationAllOf{}
	return &this
}

// NewNetsuiteDestinationAllOfWithDefaults instantiates a new NetsuiteDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewNetsuiteDestinationAllOfWithDefaults() *NetsuiteDestinationAllOf {
	this := NetsuiteDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *NetsuiteDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *NetsuiteDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *NetsuiteDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetEndpoint returns the Endpoint field value if set, zero value otherwise.
func (o *NetsuiteDestinationAllOf) GetEndpoint() string {
	if o == nil || IsNil(o.Endpoint) {
		var ret string
		return ret
	}
	return *o.Endpoint
}

// GetEndpointOk returns a tuple with the Endpoint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *NetsuiteDestinationAllOf) GetEndpointOk() (*string, bool) {
	if o == nil || IsNil(o.Endpoint) {
		return nil, false
	}
	return o.Endpoint, true
}

// HasEndpoint returns a boolean if a field has been set.
func (o *NetsuiteDestinationAllOf) HasEndpoint() bool {
	if o != nil && !IsNil(o.Endpoint) {
		return true
	}

	return false
}

// SetEndpoint gets a reference to the given string and assigns it to the Endpoint field.
func (o *NetsuiteDestinationAllOf) SetEndpoint(v string) {
	o.Endpoint = &v
}

func (o NetsuiteDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o NetsuiteDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Endpoint) {
		toSerialize["endpoint"] = o.Endpoint
	}
	return toSerialize, nil
}

type NullableNetsuiteDestinationAllOf struct {
	value *NetsuiteDestinationAllOf
	isSet bool
}

func (v NullableNetsuiteDestinationAllOf) Get() *NetsuiteDestinationAllOf {
	return v.value
}

func (v *NullableNetsuiteDestinationAllOf) Set(val *NetsuiteDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableNetsuiteDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableNetsuiteDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableNetsuiteDestinationAllOf(val *NetsuiteDestinationAllOf) *NullableNetsuiteDestinationAllOf {
	return &NullableNetsuiteDestinationAllOf{value: val, isSet: true}
}

func (v NullableNetsuiteDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableNetsuiteDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
